<template>
  <div class="sidebar">
    <div class="logo">
      <img src="../../assets/logo8.png" />
    </div>
    <div class="items body">
      <router-link :to="{ name: 'Dashboard' }">
        <div class="item">
          <div class="inner">
            <i class="fas fa-tachometer-alt"></i>
            Dashboard
          </div>
        </div>
      </router-link>
      <router-link :to="{ name: 'Projects' }">
        <div class="item">
          <div class="inner">
            <i class="fas fa-project-diagram"></i>
            Projects
            <div class="bubble">
              {{projects.length}}
            </div>
          </div>
        </div>
      </router-link>
      <router-link :to="{ name: 'Issues' }">
        <div class="item">
          <div class="inner">
            <i class="fas fa-bug"></i>
            Issues
            <div class="bubble">
              {{assignedIssues.length}}
            </div>
          </div>
        </div>
      </router-link>
    </div>
    <div class="items footer">
      <transition name="fade" mode="out-in">
        <div class="item" v-click-outside="hideMenu">
          <div class="inner">
            <div class="avatar" @click="menu = !menu">
              <img v-if="user" :src="user.photoURL" />
              <img src="../../assets/ripple.svg" />
            </div>
          </div>
          <div class="menu" v-if="menu">
            <div class="heading" v-if="user">
              <div class="avatar">
                <img :src="user.photoURL" />
              </div>
              <div class="title">
                Hello, <span>{{ getDisplayName }}</span>
              </div>
            </div>
            <div class="items">
              <div
                class="item-menu hoverable clickable"
                @click="openPage({ name: 'Profile' })"
              >
                My profile
              </div>
              <div class="item-menu clickable" @click="toggleDarkMode">
                <span v-if="darkMode"
                  >Dark Mode <i class="fas fa-moon"></i
                ></span>
                <span v-if="!darkMode"
                  >Light Mode<i class="fas fa-sun"></i
                ></span>
              </div>
            </div>
          </div>
        </div>
      </transition>
      <div class="item" @click="logoutClicked">
        <div class="inner">
          <i class="fas fa-sign-out-alt"></i>
          Logout
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapState, mapActions } from "vuex";
import ClickOutside from "vue-click-outside";
export default {
  data() {
    return {
      menu: false
    };
  },
  computed: {
    ...mapState("userModule", ["user"]),
    ...mapState("projectModule", ["projects"]),
    ...mapState("issueModule", ["assignedIssues"]),
    ...mapState(["darkMode"]),
    getDisplayName() {
      return this.user.firstName || this.user.email;
    }
  },
  methods: {
    ...mapMutations(["toggleDarkMode"]),
    ...mapActions("userModule", ["logout"]),
    logoutClicked() {
      this.logout().then(() => {
        this.$router.push({ name: "Home" });
      });
    },
    openPage(page) {
      this.menu = false;
      this.$router.push(page);
    },
    hideMenu() {
      this.menu = false;
    }
  },
  directives: {
    ClickOutside
  }
};
</script>

<style lang="scss" scoped>
.sidebar {
  flex-basis: 80px;
  background-color: #212730;
  min-height: 100vh;
  display: flex;
  flex-direction: column;
  .logo {
    margin-bottom: 50px;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-basis: 80px;
    height: 80px;
    .logo-placeholder {
      width: 40px;
      height: 40px;
      background-image: radial-gradient(
        circle 337px at 0% 2.1%,
        rgba(0, 226, 192, 1) 0.3%,
        rgb(149, 0, 248) 100%
      );
      border-radius: 100%;
    }
    img {
      height: 50px;
    }
  }
  a:hover {
    text-decoration: none;
  }
  & > .items {
    display: flex;
    flex-direction: column;
    align-items: center;
    &.body {
      flex: 1;
    }
    .item {
      margin-bottom: 15px;
      font-size: 11px;
      padding-top: 10px;
      padding-bottom: 10px;
      color: #4e5f6e;
      font-weight: 600;
      position: relative;
      width: 80px;
      .inner {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        &:hover {
          cursor: pointer;
          color: #b9c1cd;
        }
        .bubble{
          position:absolute;
          top:0;
          right:10px;
          width:20px;
          height:20px;
          line-height:20px;
          background-color: #ff2b42;
          border-radius:100%;
          text-align: center;
          color:white;
        }
      }
      .menu {
        position: absolute;
        bottom: 0;
        left: 100%;
        background-color: #292f39;
        z-index: 999;
        border-top-right-radius: 8px;
        border-bottom-right-radius: 8px;
        min-width: 200px;
        .heading {
          padding: 15px;
          display: flex;
          justify-content: center;
          align-items: center;
          flex-direction: column;
          .title {
            margin-top: 10px;
            font-size: 14px;
            white-space: nowrap;
            span {
              font-weight: bold;
              color: #6e8b9f;
            }
          }
        }
        .items {
          display: flex;
          flex-direction: column;
          width: 100%;
          border-top: 1px solid #4e5f6e;
          .item-menu {
            user-select: none;
            &.hoverable:hover {
              background-color: #262b35;
              color: #708191;
            }
            &.clickable:hover {
              cursor: pointer;
            }
            font-size: 14px;
            padding: 10px;
            i {
              margin-left: 5px;
              font-size: 16px;
            }
          }
        }
      }

      i {
        font-size: 25px;
      }
      .avatar {
        width: 44px;
        height: 44px;
        overflow: hidden;
        border-radius: 100%;
        img {
          width: 100%;
          height: 100%;
        }
      }
    }
    .router-link-active {
      .item {
        color: #ccd4e8 !important;
      }
    }
  }
}
</style>
